/*
 * Created on 2005. 1. 21
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.narusas.jCommander.util;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;

/**
 * @author 
 * 
 * 
 */
public class SequencedNameSorter {
    private ArrayList _names;

    private static final int STARTED = 0;

    private static final int ADD_TEXT = 1;

    private static final int ADD_NUMERIC = 2;

    private int _lastWork;

    private HashMap _sequences;

    private String _prefix;

    private static final Comparator SEQUENCE_COMPARATOR = new Comparator() {

        public int compare(Object o1, Object o2) {
            
            Object[] src = (Object[]) o1;
            Object[] target = (Object[]) o2;
            
            int i1 = ((Integer) src[1]).intValue();
            int i2 = ((Integer) target[1]).intValue();
            return i1 == i2 ? 0 : ( i1 < i2 ? -1 : 1); 
        }
    };

    public String[] sort(String[] names) {
        return sort(names, true);
    }

    public String[] sort(String[] names, boolean asc) {
        Arrays.sort(names);

        _names = new ArrayList(names.length);

        String prefix = null;
        ArrayList sequence = new ArrayList();

        for (int i = 0; i < names.length; i++) {
            String name = names[i];
            if (isEndWithNumber(name)) {
                addNumericSequence(sequence, name);
            } else {
                addTextSequence(sequence, name);
            }
        }
        flushSequence(sequence);

        return (String[]) _names.toArray(new String[_names.size()]);
    }

    /**
     * @param sequence
     * @param name
     */
    private void addTextSequence(ArrayList sequence, String name) {
        if (!(_lastWork == ADD_TEXT || _lastWork == STARTED)) {
            flushSequence(sequence);
        }
        _names.add(name);
        _lastWork = ADD_TEXT;
    }

    /**
     * Assumption : sequence mulst be not NULL
     * 
     * @param sequence
     */
    private void flushSequence(ArrayList sequence) {
        if (sequence.size() == 0) {
            return;
        }
        
        Collections.sort(sequence, SEQUENCE_COMPARATOR);
        
        for (int i = 0; i < sequence.size(); i++) {
            Object[] src = (Object[]) sequence.get(i);
            
            _names.add(src[2]);
        }

        sequence.clear();
    }

    /**
     * @param sequence
     * @param name
     */
    private void addNumericSequence(ArrayList sequence, String name) {
         
        Object[] res = split(name);

        if (_prefix == null || !isSamePrefix((String)res[0])) {
            flushSequence(sequence);
            _prefix = (String) res[0];
        }

        sequence.add(res);

        _lastWork = ADD_NUMERIC;
    }

    /**
     * @param name
     * @return
     */
    private boolean isSamePrefix(String name) {
        return name.equals(_prefix);
    }

    /**
     * @param name
     * @return
     */
    static Object[] split(String name) {
        int index = startOfNumber(name);
        Object[] res = new Object[3];
        res[0] = name.substring(0, index);
        res[1] = new Integer(name.substring(index));
        res[2] = name;        
        return res;
    }

    /**
     * @param name
     */
    private void addName(String name) {
        _names.add(name);
    }

    /**
     * @param preName
     * @return
     */
    public static boolean isEndWithNumber(String preName) {
        char last = preName.charAt(preName.length() - 1);
        return Character.isDigit(last);
    }

    /**
     * @param data
     * @return
     */
    public static int startOfNumber(String data) {
        int index = data.length() - 1;

        while (index >= 0) {
            char ch = data.charAt(index);
            if (!Character.isDigit(ch)) {
                break;
            }
            index--;
        }
        if (index == data.length() - 1) {
            return -1;
        }

        return index + 1;
    }

    /**
     * @param data
     * @return
     */
    public static int getSequenceNumber(String data) {
        int index = startOfNumber(data);
        return getSequenceNumber(data, index);
    }

    static int getSequenceNumber(String data, int index) {
        return Integer.parseInt(data.substring(index));
    }

}
